package com.mollyjameson.leaderboardexample.gamestates 
{
	import com.mollyjameson.leaderboardexample.utils.DebugButton;
	import flash.events.MouseEvent;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFieldType;
	
	/**
	 * ...
	 * @author Molly Jameson
	 */
	public class StateGame extends BaseGameState 
	{
		private var m_InputBoxScore:TextField; 
		private var m_InputBoxName:TextField; 
		
		public function StateGame() 
		{
			var label_name:TextField = new TextField();
			this.addChild( label_name );
			label_name.text = "Enter Name: ";
			label_name.x = 275;
			label_name.y = 20;
			label_name.autoSize = TextFieldAutoSize.LEFT;
			
			m_InputBoxName = createInputBox(label_name.x + label_name.width, label_name.y);
			m_InputBoxName.text = Main.EntryName;
			
			
			var label_score:TextField = new TextField();
			this.addChild( label_score );
			label_score.text = "Enter Score: ";
			label_score.x = 275;
			label_score.y = 40;
			label_score.autoSize = TextFieldAutoSize.LEFT;
			m_InputBoxScore = createInputBox(label_score.x + label_score.width, label_score.y);
			
			
			var btn:DebugButton = new DebugButton("Game Over, Click to submit score");
			this.addChild(btn);
			btn.x = Main.W/2 - btn.width/2;
			btn.y = Main.H - btn.height - 100;
			btn.addEventListener(MouseEvent.CLICK, onMouseClicked);
		}
		
		override public function Enter():void 
		{
			super.Enter();
			trace("Executing: StateGame::Enter");
			if ( this.stage )
			{
				stage.focus = m_InputBoxScore;
				
				m_InputBoxScore.text = (Main.EntryScore+1).toString();
			}
			
		}
		
		override public function Exit():void 
		{
			super.Exit();
			trace("Executing: StateGame::Exit");
			
			// Store the data from this "game" so that our leaderboard can sort it.
			Main.EntryScore = parseInt(m_InputBoxScore.text);
			Main.EntryName = m_InputBoxName.text;
		}
		
		private function createInputBox(xpos:Number = 0, ypos:Number = 0):TextField
		{
			var input_box:TextField = new TextField();
			input_box.type = TextFieldType.INPUT; 
            input_box.background = true; 
			input_box.border = true;
			input_box.autoSize = TextFieldAutoSize.LEFT;
			addChild(input_box);
			input_box.x = xpos;
			input_box.y = ypos;
			
			return input_box;
		}
		
		private function onMouseClicked(ev:MouseEvent):void
		{
			// Show our score
			NextState = "state_leaderboard";
		}
	}

}