package com.mollyjameson.leaderboardexample.utils 
{
	import flash.display.SimpleButton;
	import flash.display.Sprite;
	import flash.filters.GlowFilter;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.TextFieldAutoSize;
	import flash.filters.ColorMatrixFilter;
	
	/**
	 * ...
	 * @author Molly Jameson
	 */
	public class DebugButton extends SimpleButton 
	{
		private var m_Text:String;
		public function DebugButton(txt:String) 
		{
			super(getUpState(txt), getOverState(txt), getUpState(txt), getUpState(txt));
			m_Text = txt;
			this.useHandCursor = true;
		}
		
		public function grayScaleAndRemoveGlow(newLbl:String):void
		{
			this.upState = getUpState(newLbl);
			this.overState = getUpState(newLbl);
			this.downState = getUpState(newLbl);
			this.useHandCursor = false;
		}
		public function backToNormal():void
		{
			this.upState = getUpState(m_Text);
			this.downState = getUpState(m_Text);
			this.overState = getOverState(m_Text);
			this.filters = [];
			this.useHandCursor = true;
		}
		
		private function getUpState(txt:String):TextField
		{
			var tf:TextField = new TextField();
			var myFormat:TextFormat = new TextFormat();
			myFormat.size = 24;
			myFormat.color = 0xFFFFFF;
			tf.defaultTextFormat = myFormat;
			tf.text = txt;
			tf.selectable = false;
			tf.background = true;
			tf.backgroundColor = 0;
			tf.autoSize = TextFieldAutoSize.LEFT;
			return tf;
		}
		private function getOverState(txt:String):TextField
		{
			var tf:TextField = getUpState(txt);
			tf.filters = [new GlowFilter(0x00FF00)];
			return tf;
		}
	}

}